/* -*- mode:c++ -*- */

#ifndef INFO_DEFINITIONS_INCLUDED
#define INFO_DEFINITIONS_INCLUDED

#ifdef __cplusplus
const char INFO_rcsid[] = "$Id$";
#else
static const char INFO_rcsid[] = "$Id$";
#endif

/******************************************************************************
 *
 * (c) Copyright 1992-1998 Scheduling Systems Incorporated
 * All rights reserved.
 *
 * These programs are supplied under a license.  They may not be used,
 * disclosed, and/or copied except as permitted under such license
 * agreement.  Any copy must contain the above copyright notice and
 * this notice.  Use, copying, and/or disclosure of the programs is
 * strictly prohibited unless otherwise provided in the license agreement.
 *
 ******************************************************************************
 *
 * $Author$  Created By: mmorin
 * $Date$  Creation: Thu Sep 16 03:08:02 1999
 * $Revision$
 * $State$
 *
 * Revisions by:
 *      Al Asber                        (aasber)
 *      Ahmet M. Buharali               (amb, ahmet)
 *      Jeff Donner                     (jgd)
 *      Saeed Honaryar                  (sh)
 *      Massimo M. Morin                (mmorin)
 *      John D. Pararas                 (jdp)
 *      David J. Picard                 (djp, dave)
 *      John Sharko                     (jsharko)
 *      Tom Toomey                      (ttoomey)
 *
 * $Log$
 *
 *****************************************************************************/

class Information {
private:
  char* m_information;
public:
  Information(char* info="") {
    m_information = strdup(info);
  }

  Information(const Information &info) {
    m_information = strdup (info.GetInformation());
  }
  
  ~Information() {
    free (m_information);
  }

  const char* GetInformation() const { return m_information; }
  void SetInformation(const char* info) {
    free (m_information);
    m_information = strdup(info);
  }

  Information& operator= (const Information& info) {
    SetInformation(info.GetInformation());
    return *this;
  }
  friend bool operator< (const Information& info1,
			 const Information& info2) {
    return strcmp(info1.GetInformation(), info2.GetInformation()) < 0;
  }	
  friend bool operator> (const Information& info1,
			 const Information& info2) {
    return strcmp(info1.GetInformation(), info2.GetInformation()) > 0;
  }	

  friend bool operator== (const Information& info1,
			  const Information& info2) {
    return strcmp(info1.GetInformation(), info2.GetInformation()) == 0;
  }
  
  friend ostream& operator<<(ostream &os, const Information& info) {
    os << info.GetInformation();
    return os;
  }
  
};

#endif /* INFO_DEFINITIONS_INCLUDED */
