/* -*- mode:c++ -*- */

#ifndef LIST_DEFINITIONS_INCLUDED
#define LIST_DEFINITIONS_INCLUDED

#ifdef __cplusplus
const char LIST_rcsid[] = "$Id$";
#else
static const char LIST_rcsid[] = "$Id$";
#endif

/******************************************************************************
 *
 * (c) Copyright 1992-1998 Scheduling Systems Incorporated
 * All rights reserved.
 *
 * These programs are supplied under a license.  They may not be used,
 * disclosed, and/or copied except as permitted under such license
 * agreement.  Any copy must contain the above copyright notice and
 * this notice.  Use, copying, and/or disclosure of the programs is
 * strictly prohibited unless otherwise provided in the license agreement.
 *
 ******************************************************************************
 *
 * $Author$  Created By: mmorin
 * $Date$  Creation: Tue Sep 14 07:30:21 1999
 * $Revision$
 * $State$
 *
 * Revisions by:
 *      Al Asber                        (aasber)
 *      Ahmet M. Buharali               (amb, ahmet)
 *      Jeff Donner                     (jgd)
 *      Saeed Honaryar                  (sh)
 *      Massimo M. Morin                (mmorin)
 *      John D. Pararas                 (jdp)
 *      David J. Picard                 (djp, dave)
 *      John Sharko                     (jsharko)
 *      Tom Toomey                      (ttoomey)
 *
 * $Log$
 *
 *****************************************************************************/
#include <fstream.h>

#include "Node.h"

struct StatisticsType {
  int  data[100][2];
  char names[100][32];
};

class List {
private:
  Node* m_head;
  Node* m_tail;
  int m_nObjects;
public:
  List();
  ~List();

  void DumpStatistics(ostream &outfile);
  void Load (const char* fname = NULL);
  void Save (const char* fname = NULL, bool stats=false);
  void RecordStatistics (StatisticsType &stat);
  
};

#endif /* LIST_DEFINITIONS_INCLUDED */
