/* -*- mode:c++ -*- */

#ifndef TREE_DEFINITIONS_INCLUDED
#define TREE_DEFINITIONS_INCLUDED

#ifdef __cplusplus
const char TREE_rcsid[] = "$Id$";
#else
static const char TREE_rcsid[] = "$Id$";
#endif

/******************************************************************************
 *
 * (c) Copyright 1992-1998 Scheduling Systems Incorporated
 * All rights reserved.
 *
 * These programs are supplied under a license.  They may not be used,
 * disclosed, and/or copied except as permitted under such license
 * agreement.  Any copy must contain the above copyright notice and
 * this notice.  Use, copying, and/or disclosure of the programs is
 * strictly prohibited unless otherwise provided in the license agreement.
 *
 ******************************************************************************
 *
 * $Author$  Created By: mmorin
 * $Date$  Creation: Tue Sep 14 06:19:43 1999
 * $Revision$
 * $State$
 *
 * Revisions by:
 *      Al Asber                        (aasber)
 *      Ahmet M. Buharali               (amb, ahmet)
 *      Jeff Donner                     (jgd)
 *      Saeed Honaryar                  (sh)
 *      Massimo M. Morin                (mmorin)
 *      John D. Pararas                 (jdp)
 *      David J. Picard                 (djp, dave)
 *      John Sharko                     (jsharko)
 *      Tom Toomey                      (ttoomey)
 *
 * $Log$
 *
 *****************************************************************************/

#include "basics/sysconf.h"     /* should go before any other includes */
class Tree {
private:
  char* m_info;
  Tree* m_left;
  Tree* m_right;
  int 	m_heights;
  
public:
  Tree();
  ~Tree();

  void SetFather (Tree* father) { m_father = father; }
  void GetHeight () { return m_height; }
  Tree* UpLeft();
  
  void Insert(char* info);
  void Save(fstream &outfile);
  
}
#endif /* TREE_DEFINITIONS_INCLUDED */
